﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;
using NHibernate;
using NHibernate.Linq;
using NHibernate.Transform;

namespace FluentNhibernate2100ErrorTest
{
    class Program
    {
        static void Main(string[] args)
        {
            // article showing loop through query several times method
            // http://stackoverflow.com/questions/6293375/how-can-i-use-nhibernate-to-retrieve-data-when-the-where-in-have-thousands-o

            // fill the department table
            CRUDOperations crudStuff = new CRUDOperations();

            crudStuff.CreateDepartment("Operations");
            crudStuff.CreateDepartment("Personnel");
            crudStuff.CreateDepartment("Sales");
            crudStuff.CreateDepartment("Shipping");

            // fill the person table
            // read first names
            List<string> firstNameList = new List<string>();
            using (StreamReader sr = new StreamReader(@"..\..\firstnames.txt"))
            {
                string line;
                while ((line = sr.ReadLine()) != null)
                    firstNameList.Add(line);
            }

            // read last names
            List<string> lastNameList = new List<string>();
            using (StreamReader sr = new StreamReader(@"..\..\lastnames.txt"))
            {
                string line;
                while ((line = sr.ReadLine()) != null)
                    lastNameList.Add(line);
            }

            // do this 3 times
            for (int j = 0; j < 3; j++)
            {
                for (int i = 0; i < firstNameList.Count && i < lastNameList.Count; i++)
                {
                    crudStuff.CreatePerson(firstNameList[i], lastNameList[i], 1);
                }
            }

            // this code will generate an error
            // "The incoming tabular data stream (TDS) remote procedure call (RPC) protocol stream is incorrect. Too many parameters were provided in this RPC request. The maximum is 2100."

            /*
            using (ISession db = MSSQLSessionFactory.OpenSession())
            {
                List<int> personList = 
                    (from p in db.Query<Person>() 
                     select p.id).ToList();

                var departmentList =
                    (from d in db.Query<Department>()
                     where !personList.Contains(d.id)
                     select d.name).ToList();

                foreach (var item in departmentList)
                {
                    Console.WriteLine(item);
                }

            }
            */

            using (ISession db = MSSQLSessionFactory.OpenSession())
            {
                var departmentList =
                  db.CreateSQLQuery("SELECT name FROM department WHERE id NOT in (SELECT department FROM person)")
                    .SetResultTransformer(Transformers.AliasToBean<DepartmentNameRecord>())
                    .List<DepartmentNameRecord>()
                    .ToList();

                foreach (var item in departmentList)
                {
                    Console.WriteLine(item.name);
                }
            }


            Console.ReadKey();
        }
    }
}
